unit LPT2MID2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MidiOut, StdCtrls, PORT_32, ExtCtrls, Buttons, Spin;

type
  TLPT2MIDMainForm = class(TForm)
    MidiOutput: TMidiOutput;
    HwCtrl: TVicPort;
    KeybScan: TTimer;
    BitBtn1: TBitBtn;
    G_Read: TGroupBox;
    Label11: TLabel;
    Label14: TLabel;
    RPin1: TCheckBox;
    RPin2: TCheckBox;
    RPin3: TCheckBox;
    RPin4: TCheckBox;
    RPin5: TCheckBox;
    RPin6: TCheckBox;
    Rpin7: TCheckBox;
    RPin8: TCheckBox;
    RPin9: TCheckBox;
    RPin10: TCheckBox;
    RPin11: TCheckBox;
    RPin12: TCheckBox;
    RPin13: TCheckBox;
    RPin14: TCheckBox;
    RPin15: TCheckBox;
    RPin16: TCheckBox;
    RPin17: TCheckBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    cmbOutput: TComboBox;
    GroupBox3: TGroupBox;
    Label19: TLabel;
    L_LPTs: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    L_Base: TLabel;
    SpinLPT: TSpinEdit;
    MidiChannel: TSpinEdit;
    VelocityOn: TSpinEdit;
    VelocityOff: TSpinEdit;
    KeyShift: TSpinEdit;
    OctaveShift: TSpinEdit;
    PatchNumber: TSpinEdit;
    BankMSB: TSpinEdit;
    BankLSB: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label1: TLabel;
    BitBtn2: TBitBtn;
    LastNote: TLabel;
    AllNotesOff: TBitBtn;


    
    procedure OpenDevs;
    procedure CloseDevs;
    procedure cmbOutputChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure KeybScanTimer(Sender: TObject);
    procedure SpinLPTChange(Sender: TObject);
    procedure MidiChannelChange(Sender: TObject);
    procedure VelocityOnChange(Sender: TObject);
    procedure VelocityOffChange(Sender: TObject);
    procedure KeyShiftChange(Sender: TObject);
    procedure OctaveShiftChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure PatchNumberChange(Sender: TObject);
    procedure BankMSBChange(Sender: TObject);
    procedure BankLSBChange(Sender: TObject);
    procedure AllNotesOffClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LPT2MIDMainForm: TLPT2MIDMainForm;
 CPinRead : array[1..25] of TCheckBox;
 KeyWasPressed : array[0..127] of Boolean;
 Key : array [1..12] of byte;
 Octave : array [1..5] of byte;
 MidiChan, VelOn, VelOff, KShift,
 OShift, PatchNum, BnkMSB, BnkLSB : Byte;

 implementation

uses About;




{$R *.DFM}

procedure PatchSet;
begin
   with LPT2MIDMainForm do
   begin

   Midioutput.PutShort($B0+MidiChan, 0, BnkMSB);
   Midioutput.PutShort($B0+MidiChan, 32, BnkLSB);
   Midioutput.PutShort($C0+MidiChan,PatchNum, 0);
   end;
end;

procedure ShowLPT;

begin
  with LPT2MIDMainForm,HwCtrl do
  begin
   SpinLPT.Enabled:=ActiveHW;
   SpinLPT.MaxValue:=LPTNumPorts;
   L_LPTs.caption:=IntToStr(LPTNumPorts);
   L_BASE.caption:=IntToHex(LPTBasePort,3)+'h';
end;
end;


procedure TLPT2MIDMainForm.OpenDevs;

  begin
	{ Use selected devices }

	MidiOutput.ProductName := cmbOutput.Text;

	{ Open devices }

	MidiOutput.Open;
  end;

procedure TLPT2MIDMainForm.CloseDevs;

  begin
          MidiOutput.Close;
  end;




procedure TLPT2MIDMainForm.cmbOutputChange(Sender: TObject);
begin
	{ Close and reopen devices with changed device selection }
	Cursor := crHourglass;
	CloseDevs;
	OpenDevs;
        PatchSet;
    Cursor := crDefault;
end;

procedure TLPT2MIDMainForm.FormCreate(Sender: TObject);


var
	thisDevice: Word;
        i : byte;
        j : byte;
begin
     Cursor := crHourglass;

	{ Load the lists of installed MIDI Output devices }

	cmbOutput.Clear;
	for thisDevice := 0 To MidiOutput.NumDevs - 1 do
		begin
		MidiOutput.DeviceID := thisDevice;
		cmbOutput.Items.Add(MidiOutput.ProductName);
		end;



	cmbOutput.ItemIndex := 0;
	OpenDevs;
        PatchSet;
    Cursor := crDefault;

         {Opening LPT Port(s)}
  HwCtrl.OpenDriver;
  if not HwCtrl.ActiveHW then
  begin
    MessageBeep(0);
    Application.MessageBox('The driver not found',
                           ' Warning! ',mb_OK or mb_ICONHAND);
  end
  else begin
           for j:=1 to 17 do
     HwCtrl.Pin[j]:=TRUE;

         KeybScan.Enabled:=TRUE;
       end;
 ShowLpt;


Key [1] := 1;
Key [2] := 2;
Key [3] := 3;
Key [4] := 4;
Key [5] := 5;
Key [6] := 6;
Key [7] := 7;
Key [8] := 8;
Key [9] := 9;
Key [10]:=14;
Key [11]:=16;
Key [12]:=17;

Octave [1] := 10;
Octave [2] := 11;
Octave [3] := 12;
Octave [4] := 13;
Octave [5] := 15;

VelOn:=VelocityOn.Value;
VelOff:=VelocityOff.Value;

        for i:= 0 to 127 do
        KeyWasPressed[i]:=FALSE;
     Cursor := crDefault;

   with HWCtrl do
 begin
   CPinRead[ 1]:=RPin1;
   CPinRead[ 2]:=RPin2;
   CPinRead[ 3]:=RPin3;
   CPinRead[ 4]:=RPin4;
   CPinRead[ 5]:=RPin5;
   CPinRead[ 6]:=RPin6;
   CPinRead[ 7]:=RPin7;
   CPinRead[ 8]:=RPin8;
   CPinRead[ 9]:=RPin9;
   CPinRead[10]:=RPin10;
   CPinRead[11]:=RPin11;
   CPinRead[12]:=RPin12;
   CPinRead[13]:=RPin13;
   CPinRead[14]:=RPin14;
   CPinRead[15]:=RPin15;
   CPinRead[16]:=RPin16;
   CPinRead[17]:=RPin17;
   end;

end;






procedure TLPT2MIDMainForm.KeybScanTimer(Sender: TObject);
var


     nPinR, nPinW, nKey: Byte;

begin
 with HWCtrl do
  begin

          if ActiveHW  then
   begin
     
    {Scycle Request for Searching Key Pressed begins here:}

      for nPinW:=1 to 12 do
    begin
        HwCtrl.Pin[Key[nPinW]]:=FALSE;

        for nPinR:=1 to 5 do
      begin
         {Calculating Key number:}
        nKey:=((nPinR+OShift-1)*12+KSHift+nPinW+35) And $7F;
        {'And $7F' to keep within key number range}

          if Not Pin[Octave[nPinR]] and Not KeyWasPressed[nKey] then
       begin

        CPinRead[Octave[nPinR]].Checked:=TRUE;
        CPinRead[Key[nPinW]].Checked:=TRUE;
        Midioutput.PutShort($90+MidiChan, nKey,VelOn);
        KeyWasPressed[nKey]:=TRUE;
       LastNote.Caption:= 'Last Pressed Key #  '+ IntToStr(nKey);
       end;

        If Pin[Octave[nPinR]] and KeyWasPressed[nkey]then
       begin

        Midioutput.PutShort($80+MidiChan,nKey,VelOff);
        KeyWasPressed[nKey]:=FALSE;
        CPinRead[Octave[nPinR]].Checked:=FALSE;
        CPinRead[Key[nPinW]].Checked:=FALSE;
       end;

      end;
        HwCtrl.Pin[Key[nPinW]]:=TRUE;

   end;

  end;



 end;

end;

procedure TLPT2MIDMainForm.SpinLPTChange(Sender: TObject);
begin

  with HwCtrl do
  begin
    LPTNumber:=SpinLPT.Value;
  end;
  ShowLPT;
end;



procedure TLPT2MIDMainForm.MidiChannelChange(Sender: TObject);
begin
MidiChan:=MidiChannel.Value-1;
end;

procedure TLPT2MIDMainForm.VelocityOnChange(Sender: TObject);
begin
 VelOn:=VelocityOn.Value;
end;

procedure TLPT2MIDMainForm.VelocityOffChange(Sender: TObject);
begin
VelOff:=VelocityOff.Value;
end;

procedure TLPT2MIDMainForm.KeyShiftChange(Sender: TObject);
begin
KShift:=KeyShift.Value;
end;

procedure TLPT2MIDMainForm.OctaveShiftChange(Sender: TObject);
begin
OShift:=OctaveShift.Value;
end;

procedure TLPT2MIDMainForm.BitBtn1Click(Sender: TObject);
begin
 KeybScan.Enabled:=FALSE;
 CloseDevs;
  HwCtrl.CloseDriver;
 Close;
end;

procedure TLPT2MIDMainForm.BitBtn2Click(Sender: TObject);
begin
AboutBox.ShowModal;
end;

procedure TLPT2MIDMainForm.PatchNumberChange(Sender: TObject);

begin
        PatchNum:=PatchNumber.Value;
        PatchSet;
end;

procedure TLPT2MIDMainForm.BankMSBChange(Sender: TObject);
begin

       BnkMSB:=BankMSB.Value;
       PatchSet;
end;

procedure TLPT2MIDMainForm.BankLSBChange(Sender: TObject);
begin

       BnkLSB:=BankLSB.Value;
       PatchSet;

end;
procedure TLPT2MIDMainForm.AllNotesOffClick(Sender: TObject);
begin
          Cursor := crHourglass;
	CloseDevs;
	OpenDevs;
        PatchSet;
        Cursor := crDefault;
end;

end.
